// Code generated by gowrap. DO NOT EDIT.
// template: ../../assets/templates/middleware/telemetry_default
// gowrap: http://github.com/hexdigest/gowrap

package middleware

//go:generate gowrap gen -p git.perx.ru/perxis/perxis-go/images -i Images -t ../../assets/templates/middleware/telemetry_default -o telemetry_middleware.go -l ""

import (
	"context"
	"time"

	pkgId "git.perx.ru/perxis/perxis-go/id"
	"git.perx.ru/perxis/perxis-go/images"
	"git.perx.ru/perxis/perxis-go/pkg/auth"
	"git.perx.ru/perxis/perxis-go/pkg/files"
	"git.perx.ru/perxis/perxis-go/pkg/telemetry/metrics"
	"go.opentelemetry.io/otel"
	"go.opentelemetry.io/otel/attribute"
	otelmetric "go.opentelemetry.io/otel/metric"
	"go.opentelemetry.io/otel/trace"
)

type spaceGetter interface {
	GetSpaceID() string
}

// telemetryMiddleware implements images.Images interface instrumented with opentracing spans
type telemetryMiddleware struct {
	images.Images
	_instance      string
	requestMetrics *metrics.RequestMetrics
	_spanDecorator func(span trace.Span, params, results map[string]interface{})
}

// TelemetryMiddleware returns telemetryMiddleware
func TelemetryMiddleware(base images.Images, instance string, spanDecorator ...func(span trace.Span, params, results map[string]interface{})) telemetryMiddleware {
	requestMetrics, err := metrics.GetRequestMetrics()
	if err != nil {
		panic(err)
	}

	d := telemetryMiddleware{
		Images:         base,
		_instance:      instance,
		requestMetrics: requestMetrics,
	}

	if len(spanDecorator) > 0 && spanDecorator[0] != nil {
		d._spanDecorator = spanDecorator[0]
	}

	return d
}

// Get implements images.Images
func (_d telemetryMiddleware) Get(ctx context.Context, source *files.File, opts *images.GetOptions) (result *files.File, err error) {
	var att = []attribute.KeyValue{
		attribute.String("service", "Images"),
		attribute.String("method", "Get"),
	}
	attributes := otelmetric.WithAttributeSet(attribute.NewSet(att...))

	start := time.Now()
	ctx, _span := otel.Tracer(_d._instance).Start(ctx, "Images.Get")
	defer _span.End()

	result, err = _d.Images.Get(ctx, source, opts)

	_d.requestMetrics.DurationMilliseconds.Record(ctx, time.Since(start).Milliseconds(), attributes)

	caller, _ := pkgId.NewObjectId(auth.GetPrincipal(ctx))
	if caller != nil {
		att = append(att, attribute.String("caller", caller.String()))
	}

	_d.requestMetrics.Total.Add(ctx, 1, otelmetric.WithAttributeSet(attribute.NewSet(att...)))

	if _d._spanDecorator != nil {
		_d._spanDecorator(_span, map[string]interface{}{
			"ctx":    ctx,
			"source": source,
			"opts":   opts}, map[string]interface{}{
			"result": result,
			"err":    err})
	} else if err != nil {
		_d.requestMetrics.FailedTotal.Add(ctx, 1, attributes)

		_span.RecordError(err)
		_span.SetAttributes(attribute.String("event", "error"))
		_span.SetAttributes(attribute.String("message", err.Error()))
	}

	return result, err
}
